package bbmo;

class Consumer
    implements Runnable
{
    //~ Instance variables .....................................................

    protected BoundedBuffer bb = null;

    //~ Constructors ...........................................................

    /*@ behavior
       @   requires bb != null;
       @   assignable this.bb;
       @   ensures this.bb == bb;
       @*/
    public Consumer(BoundedBuffer bb)
    {
        this.bb = bb;
    }

    //~ Methods ................................................................

    /*@also
       @ behavior
       @   requires this.bb != null;
       @   diverges true;
       @   ensures false;
       @*/
    public void run()
    {
        while (true)
        {
            Object item = bb.fetch();
        }
    }
}
